UNIT uHandWaffe;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses uNichtLebende,uLebende,uFigur, uWaffe,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls;

type
  THandWaffe = class(TNichtLebende)

  public //Attribute
    Typ : String;
    Munition : Integer;
    MaxSchuss : Integer;
    Schaden : Integer;
    Schussfrequenz : Integer;
    constructor create(pX, pY, pWidth, pHeight,pMunition, pMaxSchuss, pSchaden, pSchussfrequenz : Integer ; Pfad, pTyp : String);
    procedure Event(figur : TFigur);override;
   end;

implementation
  uses umain;
constructor THandWaffe.create(pX, pY, pWidth, pHeight,pMunition, pMaxSchuss, pSchaden, pSchussfrequenz : Integer ; Pfad, pTyp : String);
Begin
     Typ := pTyp;
     Munition := pMunition;
     MaxSchuss := pMaxSchuss;
     Schaden := pSchaden;
     Schussfrequenz := pSchussfrequenz;

     X := pX;
     Y := pY;

     Picture := TBitmap.Create;
     Picture.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad + '.bmp');

     Width := pWidth;
     Height := pHeight;
     
     PictureInvert := TBitmap.Create;
     PictureInvert.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad +  '_n.bmp');
End;

procedure THandWaffe.Event(figur : TFigur);
Var i : Integer;
    eing : Boolean;
Begin
     eing := False; // gibt an, ob die Waffe schon eingesammelt wurde, dann keine Munition

     // Wenn schon vorhanden, Munition fr Waffe
     For i := 0 to High(Figur.Waffe) Do Begin
         If (Figur.Waffe[i].Typ = Typ) and (eing = False) Then
         Begin
              Figur.Waffe[i].UebrigeSchuesse := Figur.Waffe[i].UebrigeSchuesse + Munition;
              eing := True;
              If Figur.Waffe[i].UebrigeSchuesse > Figur.Waffe[i].MaxSchuss then
                   Figur.Waffe[i].UebrigeSchuesse := Figur.Waffe[i].MaxSchuss;
         End;
     End;

     If eing = False then // Wenn Waffe noch nicht vorhanden, neu einsammeln
     Begin
          SetLength(Figur.Waffe, High(Figur.Waffe)+2);
          If Typ = 'mg' then
          Begin
                                              // TWaffe.Create(pWidth,    pHeight,  pMaxSchuss, pSchaden, pUebrigeSchuesse, pSchussfrequenz : Integer; Pfad, pTyp : String);
               Figur.Waffe[High(Figur.Waffe)] := TWaffe.Create(Width,Height, MaxSchuss, Schaden, Munition,Schussfrequenz, Typ,  Typ);
               Figur.AktuelleWaffe := Figur.Waffe[High(Figur.Waffe)];
          End
          Else If Typ = 'laser' then
          Begin
               Figur.Waffe[High(Figur.Waffe)] := TWaffe.Create(Width,Height,MaxSchuss,Schaden,Munition,Schussfrequenz,Typ,Typ);
               Figur.AktuelleWaffe := Figur.Waffe[High(Figur.Waffe)];
          End;
     End;
     spieler.AktuelleWaffe.change(spieler.richtung);
End;



end.
