UNIT uSchuss;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses uNichtLebende,uLebende, uFigur,uGegner,uRespawn, uStart,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls;

type
  TSchuss = class(TNichtLebende)

  public //Attribute
    Schaden : Integer;
    vX : Real;

    constructor create(pX, pY, pWidth, pHeight, pSchaden : Integer; pvX : Real; Pfad : String);
    procedure Event(figur : TFigur);override;
    procedure EventGegner(gegner : Tgegner);override;
   end;

implementation

uses umain;

constructor TSchuss.create(pX, pY, pWidth, pHeight, pSchaden : Integer; pvX : Real; Pfad : String);
Begin
     Schaden := pSchaden;
     vX := pvX;

     X := pX;
     Y := pY;

     Picture := TBitmap.Create;
     Picture.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad + '.bmp');

     Width := pWidth;
     Height := pHeight;
     
     PictureInvert := TBitmap.Create;
     PictureInvert.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad +  '_n.bmp');
End;


procedure TSchuss.Event(figur : TFigur);
Var i : Integer;
    gef : Boolean;
Begin
     //Lebenspunkt abziehen
     If figur.Unverwundbar = False then figur.lebenspunkte := figur.lebenspunkte - schaden; // Schaden abziehen

     //Wenn Figur kurz vorherschonmal getroffen und leben verloren hat --> kurze Zeit unverwunbar
     If figur.Lebenspunkte = 1 Then // wenn jetzt nur noch 1 Lebenspunkt --> Unverwundbar fr 5 Sekunden
     Begin
          figur.Unverwundbar := True;
          Form1.tmrUnverwundbar.Enabled := True;
     End;

     If Figur.Lebenspunkte <= 0 Then Begin // wenn keine Lebenspunkte mehr
        Figur.AnzLeben := Figur.AnzLeben - 1; // ein leben abziehen
        Figur.Lebenspunkte := 2;

        If Figur.AnzLeben >= 0 then Begin   //wenn Figur noch lebt, dann suche nach Respawn/Startpunkten
          i := High(NichtLebende);
          gef := False;

          while (i >= 0) and (gef = false) Do Begin
              If (NichtLebende[i] is TRespawn) then Begin
                 If (NichtLebende[i] as TRespawn).Activated = True then Begin
                    Spieler.X := NichtLebende[i].X-250;
                    Spieler.Y := NichtLebende[i].Y;
                    Spieler.vY := 0;
                    zeit := 0;
                    gef := True;
                 End;
              End;
              i := i - 1;
          End;

          If gef = False then Begin    //Wenn keinen Respawnpoint gefunden
          i := High(NichtLebende);     //nimm nen Startpunkt
            while (i >= 0) and (gef = false) Do Begin
                If (NichtLebende[i] is TStart) then Begin
                   Spieler.X := NichtLebende[i].X;
                   Spieler.Y := NichtLebende[i].Y;
                   Spieler.vY := 0;
                   zeit := 0;
                   gef := True;
                End;
                i := i - 1;
            End;
          End;
        End
     End;

End;

procedure TSchuss.EventGegner(gegner : Tgegner);
Begin
     gegner.lebenspunkte := gegner.lebenspunkte - schaden;  // Wenn ein Gegner getroffen wird, schadet es ihm
End;


end.
