UNIT uBewegtesHinderniss;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses uHinderniss, uNichtLebende,uLebende, uFigur,urespawn, ustart,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls;

type
  TBewegtesHinderniss = class(THinderniss)

  public //Attribute
    Bottom : Integer;
    Left : Integer;
    Right : Integer;
    Top : Integer;
    vX : Integer;
    vY : Integer;

    constructor create(pX, pY, pWidth, pHeight, pID, pLeft, pRight, pBottom, pTop, pvx, pvy : Integer; pToedlich : Boolean ; Pfad : String);
    procedure Event(figur : TFigur);override; //Kollision

   end;

implementation

uses uMain;

constructor TBewegtesHinderniss.create(pX, pY, pWidth, pHeight, pID, pLeft, pRight, pBottom, pTop, pvx, pvy : Integer; pToedlich : Boolean ; Pfad : String);
Begin
     X := pX;
     Y := pY;
     ID := pID;
     Left := pLeft;
     Right := pRight;
     Bottom := pBottom;
     Top := pTop;
     vX := pvX;
     vY := pvY;
     Toedlich := pToedlich;
     Picture := TBitmap.Create;
     Picture.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad + '.bmp');
     Width := pWidth;
     Height := pHeight;
     PictureInvert := TBitmap.Create;
     PictureInvert.LoadFromFile(ExtractFilePath(ParamStr(0))+'\bilder\' + Pfad +  '_n.bmp');
End;

procedure TBewegtesHinderniss.Event(figur : TFigur);
Var str : String;
    ax, ay,i,a : Integer;
    gef:boolean;
Begin

if toedlich = false then    //wenn bewegtes Hindernis ttlich?
begin
 if (dy<0) and ((spieler.y - spieler.height) >(y-abs(dy)-5)) then      //oben;
  begin
  steheauf:=Y+1;
  steheaufhind:=id;     //aktuelle Runterfallgrenzen werden gesetzt
  falllinks:=x;
  fallrechts:=x+width;
  end;


 if (dy>0) and ((spieler.y) <(y-height+abs(dy)+5)) then  //unten;
  begin
  spieler.vy:=0;
  spieler.y:=y-height-2;     //Spieler wird auf 2 Pixel ber das Hinderniss gesetzt
  end;


if (dx>0) and ((spieler.x+230+spieler.width)<(x))  then       //von links kommend
 begin
  spieler.x:= X-250-spieler.width-11;
 end;

if (dx<0) and ((spieler.x+270)>(x+width)) then              //von rechts kommend
 begin
  spieler.x:= X+width-250+12;
 end;

end

else
 begin
 Figur.AnzLeben := Figur.AnzLeben - 1; // ein leben abziehen
 Figur.Lebenspunkte := 2;  // Lebenspunkte reseten

  //Wenn Tot dann suche nach Respawn/Startpunkten
  If Figur.AnzLeben >= 0 then Begin
    i := High(NichtLebende);
    gef := False;
    while (i >= 0) and (gef = false) Do Begin
      If (NichtLebende[i] is TRespawn) then Begin
        If (NichtLebende[i] as TRespawn).Activated = True then Begin
         Spieler.X := NichtLebende[i].X - 250;
         spieler.Y := NichtLebende[i].Y;
         Spieler.vY := 0;
         zeit := 0;
         gef := True;
         End;
        End;
        i := i - 1;
       End;

       If gef = False then Begin      //wenn kein respawnpunkt gefunden wurde
          i := High(NichtLebende);
            while (i >= 0) and (gef = false) Do Begin
                If (NichtLebende[i] is TStart) then Begin
                   Spieler.X := NichtLebende[i].X;
                   Spieler.Y := NichtLebende[i].Y;
                   Spieler.vY := 0;
                   zeit := 0;
                   gef := True;
                End;
                i := i - 1;
            End;
          End;
        End
     End;
end;

end.







{
     SetLength(Schnitte, 0);

     For i := 1 to 4 Do Begin // alle 4 Geraden des Hindernisses
         For a := 1 to 4 Do Begin // mit allen 4 Eckpunkten des Spielers prfen

            If a = 1 then Begin // links oben
              xa := Spieler.X +250 ;// - dx;
              ya := Spieler.Y - dy;
            End Else If a = 2 Then Begin // rechts oben
              xa := Spieler.X +250 + Spieler.Width - dx;
              ya := Spieler.Y - dy;
            End Else If a = 3 then Begin //links unten
              xa := Spieler.X +250 - dx;
              ya := Spieler.Y - Spieler.Height -dy;
            End Else If a = 4 then Begin // rechts unten
              xa := Spieler.X +250 + Spieler.Width - dx;
              ya := Spieler.Y - Spieler.Height - dy;
            End;
            vxa := dx;
            vya := dy;

            If i = 1 then Begin // links
              xb := X;
              yb := Y - Height;
              vxb := 0;
              vyb := 1;

              // Parameter berechnen
              If (vxa * vyb - vya * vxb) <> 0 Then Begin
                s := (-1 * (xa * vyb - ya * vxb - xb * vyb + yb * vxb)) / (vxa * vyb - vya * vxb);
              End Else Begin
                  s := -999999999;
              End;

              // Schnittpunkt berechnen
              xs := xa + s * vxa;
              ys := ya + s * vya;

              If (s <> -999999999) and (dx > 0) and ((Y - Height) < ys) and (ys < Y) Then Begin // Schnittpunkt mit links
                SetLength(Schnitte, High(Schnitte) + 2);
                Schnitte[High(Schnitte)].l := Sqrt((xs-xa)*(xs-xa)+(ys-ya)*(ys-ya));
                Schnitte[High(Schnitte)].kante := i;
              End;

            End Else if i = 2 then Begin // oben
              xb := X;
              yb := Y;
              vxb := 1;
              vyb := 0;

              // Parameter berechnen
              If (vxa * vyb - vya * vxb) <> 0 Then Begin
                s := (-1 * (xa * vyb - ya * vxb - xb * vyb + yb * vxb)) / (vxa * vyb - vya * vxb);
              End Else Begin
                  s := -999999999;
              End;

              // Schnittpunkt berechnen
              xs := xa + s * vxa;
              ys := ya + s * vya;

              If (s <> -999999999) and (dy < 0) and ((X) < xs) and (xs < X + Width) Then Begin // Schnittpunkt mit oben
                SetLength(Schnitte, High(Schnitte) + 2);
                Schnitte[High(Schnitte)].l := Sqrt((xs-xa)*(xs-xa)+(ys-ya)*(ys-ya));
                Schnitte[High(Schnitte)].kante := i;
              End;
            End Else If i = 3 Then Begin  // rechts
              xb := X + Width;
              yb := Y;
              vxb := 0;
              vyb := -1;

              // Parameter berechnen
              If (vxa * vyb - vya * vxb) <> 0 Then Begin
                s := (-1 * (xa * vyb - ya * vxb - xb * vyb + yb * vxb)) / (vxa * vyb - vya * vxb);
              End Else Begin
                  s := -999999999;
              End;

              // Schnittpunkt berechnen
              xs := xa + s * vxa;
              ys := ya + s * vya;

              If (s <> -999999999) and (dx < 0) and((Y - Height) < ys) and (ys < Y) Then Begin // Schnittpunkt mit rechts
                SetLength(Schnitte, High(Schnitte) + 2);
                Schnitte[High(Schnitte)].l := Sqrt((xs-xa)*(xs-xa)+(ys-ya)*(ys-ya));
                Schnitte[High(Schnitte)].kante := i;
              End;

            End Else if i = 4 then Begin  // unten
              xb := X + Width;
              yb := Y - Height;
              vxb := -1;
              vyb := 0;

              // Parameter berechnen
              If (vxa * vyb - vya * vxb) <> 0 Then Begin
                s := (-1 * (xa * vyb - ya * vxb - xb * vyb + yb * vxb)) / (vxa * vyb - vya * vxb);
              End Else Begin
                  s := -999999999;
              End;

              // Schnittpunkt berechnen
              xs := xa + s * vxa;
              ys := ya + s * vya;

              If (s <> -999999999) and (dy > 0) and ((X) < xs) and (xs < X + Width) Then Begin // Schnittpunkt mit unten
                SetLength(Schnitte, High(Schnitte) + 2);
                Schnitte[High(Schnitte)].l := Sqrt((xs-xa)*(xs-xa)+(ys-ya)*(ys-ya));
                Schnitte[High(Schnitte)].kante := i;
              End;

            End;

         End;
     End;

     min := 999999;
     min_i := -1;
     
     For i := 0 to High(Schnitte) Do Begin
        If Schnitte[i].l < min then Begin
          min := Schnitte[i].l;
          min_i := Schnitte[i].kante;
        End;
     End;

     Case min_i Of
      1 : Begin
            Form1.lblPeiler.Caption := 'links';

            Spieler.X := X - Spieler.Width - 250;
          End;
      2 : Begin
            Form1.lblPeiler.Caption := 'oben';

            LaufX := Y-1;
            stehhind := ID;
          End;
      3 : Begin
            Form1.lblPeiler.Caption := 'rechts';

            Spieler.X := X + Width - 250;
          End;
      4 : Begin
            Form1.lblPeiler.Caption := 'unten';

            Spieler.vY := -10;
            zeit := 1;
          End
     Else Begin  // wenn er oben drauf steht
            Form1.lblPeiler.Caption := '!!! Scheisse !!!';

            LaufX := Y-1;
            stehhind := ID;
          End;

     End;
     {
     str := 'schlecht!';

     //        =>  t(x) = m * x + n
     // von links unten nach oben rechts
     //      I  : Y + H = m1 * X + n1
     //     II  : Y     = m1 * (X + W) + n1
     //    III  : m1    = (Y - (Y - H))/(X + W - X) = H / W
     //III in I : Y + H = (H / W) * X + n1
     // -->       n1    =  (Y + H) - (H / W) * X

     m1 := Height / Width;
     n1 := (Y - Height) - (m1 * X);

     //        =>  t(x) = m * x + n
     // von links unten nach oben rechts
     //      I  : Y     = m2 * X + n2
     //     II  : Y - H = m2 * (X + W) + n2
     //    III  : m2    = ((Y - H) - Y)/(X + W - X) = -H / W
     //III in I : Y     = (-H / W) * X + n2
     // -->       n2    = (Y) - (-H / W) * X

     m2 := (-1 * Height / Width);
     n2 := Y - (m2 * X);

     str := 'm1: ' + FloatToStr(m1) + ' n1: ' + FloatToStr(n1) + '  m2: ' + FloatToStr(m2) + ' n2: ' + FloatToStr(n2) + '   ';

     If (Spieler.Y < (m1 * (Spieler.X+250) + n1)) Then Begin // wenn sich der Spieler unterhalb von der 1. Diagonale befindet
         str := str + ' unter 1.';

         If Spieler.Y < (m2 * (Spieler.X+250) + n2) Then Begin // wenn sich der Spieler unterhalb von der 2. Diagonale befindet
            // von unten
            str := str + ' unter 2. --> unten';
            Spieler.vY := -10;
            zeit := 1;
         End Else Begin
            // von rechts 
            str := str + ' ueber 2. --> rechts';
            Spieler.X := X + Width - 250;
         End;

     End Else Begin
         str := str + ' ueber 1.';
         
         If (Spieler.Y)  < (m2 * (Spieler.X+250) + n2) Then Begin // wenn sich der Spieler unterhalb von der 2. Diagonale befindet

         End Else Begin
             If (abs(dY) > 0) or ((NichtLebende[stehhind].X = X) and (NichtLebende[stehhind].Y = Y) and (NichtLebende[stehhind].Height = Height) and (NichtLebende[stehhind].Width = Width)) then Begin
                // von oben
                str := str + ' ueber 2. --> oben';
                Spieler.Y := Y - 1;
                LaufX := Y-1;
                stehhind := ID;
             End Else If abs(dx) > 0 then Begin
               // von links
              str := str + ' unter 2. --> links';
              Spieler.X := X - Spieler.Width - 250;
             End;
         End;

     End;

     Form1.lblHinderniss.caption := str;

//     // von rechts --> Spieler ist rechts von der Hlfte des Hinderniss aus gesehen
//     If ((Spieler.X + 250) >= X + Width / 2) then Begin
//        s := 'rechts';
//        Spieler.X := X + Width - 250;
//     End;
//
//     // von links  --> Spieler ist links von der Hlfte des Hinderniss aus gesehen
//     If ((Spieler.X + 250) < X + Width / 2) then Begin
//        s := 'links';
//        Spieler.X := X - Spieler.Width - 250;
//     End;
//
//     // von oben  --> Spieler ist oben von der Hlfte des Hinderniss aus gesehen
//     If (Spieler.Y >= Y - Height / 2) then Begin
//        s := s + ' oben';
//        LaufX := Y;
//     End;
//
//     // von unten  --> Spieler ist unten von der Hlfte des Hinderniss aus gesehen
//     If (Spieler.Y < Y - Height / 2) then Begin
//        s := s + ' unten';
//        Spieler.vY := -10;
//        zeit := 1;
//     end;

//steheauf:=0;
}
